SystemOrganization addCategory: #'Jejak-Alt-Browser-Integration'!

ABCommand subclass: #JTraceCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jejak-Alt-Browser-Integration'!

!JTraceCommand commentStamp: '<historical>' prior: 0!
A JTraceCommand turns on or off the trace of a method.!

!JTraceCommand methodsFor: 'execution' stamp: 'ThierryGoubier 10/7/2012 21:43'!
execute
	| method |
	method := requestor selectedNode item compiledMethod.
	(JInstrumentedMethods includesKey: (Array with: method methodClass with: method selector))
		ifTrue: [ 
			method methodClass
				addSelector: method selector
				withMethod: (JInstrumentedMethods at: (Array with: method methodClass with: method selector)) ]
		ifFalse: [ JVariableProbesWriter analyse: method selector in: method methodClass ]! !

!JTraceCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/7/2012 18:00'!
icon
	^ nil! !

!JTraceCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/7/2012 18:03'!
isActive
	^ true! !

!JTraceCommand methodsFor: 'testing' stamp: 'ThierryGoubier 10/7/2012 18:03'!
isEnabled
	^ true! !

!JTraceCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/7/2012 21:42'!
label
	| aMethod |
	aMethod := requestor selectedNode item compiledMethod.
	(JInstrumentedMethods includesKey: (Array with: aMethod methodClass with: aMethod selector))
		ifTrue: [ ^ 'Trace off' ]
		ifFalse: [ ^ 'Trace on' ]! !

!JTraceCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 10/7/2012 18:01'!
shortcut
	^ nil! !

!ABMethodNode methodsFor: '*Jejak-Alt-Browser-Integration' stamp: 'ThierryGoubier 10/7/2012 18:05'!
traceCommand
	<treeAreaCommand>
	
	^ {JTraceCommand}! !
